import { ExternalTokenizer, LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const backtickQuotedString = 30;

const backTick = '`'.charCodeAt(0);
const backtickString = new ExternalTokenizer((input, stack) => {
    if (!stack.canShift(backtickQuotedString)) {
        return;
    }
    let backticks = 0;
    for (; input.next === backTick; input.advance()) {
        backticks++;
    }
    if (backticks === 0) {
        return;
    }
    let currentRun = 0;
    while (currentRun < backticks && input.next !== -1) {
        if (input.next === backTick) {
            currentRun++;
        }
        else {
            currentRun = 0;
        }
        input.advance();
    }
    input.acceptToken(backtickQuotedString);
}, { contextual: true, fallback: true });

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_identifier = {__proto__:null,true:72, false:72, nil:74, import:76, "import*":76, use:76, let:76, with:76, "with-dyns":76, "with-syms":76, "with-vars":76, default:76, set:76, setdyn:76, var:76, "var-":76, varfn:76, varglobal:76, def:76, "def-":76, defdyn:76, defglobal:76, defn:76, "defn-":76, fn:76, "short-fn":76, defmacro:76, "defmacro-":76, if:76, "if-not":76, "if-let":76, "if-with":76, when:76, "when-let":76, "when-with":76, unless:76, cond:76, case:76, match:76, while:76, for:76, forv:76, break:76, loop:76, seq:76, tabseq:76, generate:76, each:76, eachk:76, eachp:76, coro:76, yield:76, try:76, label:76, return:76, macex:76, macex1:76};
const parser = LRParser.deserialize({
  version: 14,
  states: "%QQYQROOOOQP'#C_'#C_OOQP'#C`'#C`OOQP'#Ca'#CaOOQP'#Cb'#CbOOQP'#Cc'#CcOOQP'#Cd'#CdO!dQRO'#CmO!kQRO'#CpO!rQRO'#CsO!yQRO'#CuO#QQRO'#CwOOQP'#C}'#C}OOQP'#Cx'#CxQYQROOOOQP,59X,59XO#XQRO,59XOOQP,59[,59[O#`QRO,59[OOQP,59_,59_O#gQRO,59_OOQP,59a,59aO#nQRO,59aOOQP,59c,59cO#uQRO,59cOOQP-E6v-E6vOOQP1G.s1G.sOOQP1G.v1G.vOOQP1G.y1G.yOOQP1G.{1G.{OOQP1G.}1G.}",
  stateData: "$R~OpOSPOS~OX[OY[OZ[O[[O][O^[O`VOcWOfXOhYOjZOnUOrPOsQOtROuSOvTOwUO~O__O~PYObaO~PYOecO~PYObeO~PYOegO~PYO_jO~PYObkO~PYOelO~PYObmO~PYOenO~PYOjshr~",
  goto: "!{rPPPssssssPPPPPPPPsPPsPPsPsPs!RPPPP!mi[OVWXYZ^`bdfhQ^OQ`VQbWQdXQfYQhZ]i^`bdfhi]OVWXYZ^`bdfh",
  nodeNames: "⚠ LineComment Program Identifier Number Boolean Nil Special String Pipe Comma Semicolon Quote Quasiquote Keyword ) ( Form ] [ Tuple } { Struct @[ Array @{ Table",
  maxTerm: 39,
  nodeProps: [
    ["openedBy", 15,"(",18,"[ @[",21,"{ @{"],
    ["closedBy", 16,")",-2,19,24,"]",-2,22,26,"}"]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "4{~RtXY#cYZ#c]^#cpq#cqr#trs%Ust&rtu#tvw#twx'Zxy'`yz'ez{#t{|'j|}0Q}!O'j!O!P(z!P!Q#t!Q![0V![!]1U!]!^2f!^!_#t!_!`#t!`!a#t!a!b#t!b!c2k!c!}#t!}#O4]#P#Q4b#Q#R#t#R#S#t#T#o#t#o#p4g#p#q4l#q#r4q#r#s4v~#hSp~XY#cYZ#c]^#cpq#c~#ycr~qr#ttu#tvw#tz{#t{|#t}!O#t!O!P#t!P!Q#t!Q![#t![!]#t!^!_#t!_!`#t!`!a#t!a!b#t!b!c#t!c!}#t#Q#R#t#R#S#t#T#o#t~%XVOr%Urs%ns#O%U#O#P%s#P;'S%U;'S;=`&l<%lO%U~%sOw~~%vRO;'S%U;'S;=`&P;=`O%U~&SWOr%Urs%ns#O%U#O#P%s#P;'S%U;'S;=`&l;=`<%l%U<%lO%U~&oP;=`<%l%U~&wSP~OY&rZ;'S&r;'S;=`'T<%lO&r~'WP;=`<%l&r~'`O[~~'eO`~~'jO_~~'ocr~qr#ttu#tvw#tz{#t{|#t}!O#t!O!P(z!P!Q#t!Q![.h![!]#t!^!_#t!_!`#t!`!a#t!a!b#t!b!c#t!c!}#t#Q#R#t#R#S#t#T#o#t~)Pcr~qr#ttu#tvw#tz{#t{|#t}!O#t!O!P#t!P!Q#t!Q![*[![!]#t!^!_#t!_!`#t!`!a#t!a!b#t!b!c#t!c!}#t#Q#R#t#R#S#t#T#o#t~*ces~r~qr#ttu#tvw#tz{#t{|#t}!O#t!O!P#t!P!Q#t!Q![*[![!]#t!^!_#t!_!`#t!`!a#t!a!b#t!b!c#t!c!}#t#Q#R#t#R#S*[#T#X#t#X#Y+t#Y#o#t~+ycr~qr#ttu#tvw#tz{#t{|#t}!O#t!O!P#t!P!Q#t!Q![-U![!]#t!^!_#t!_!`#t!`!a#t!a!b#t!b!c#t!c!}#t#Q#R#t#R#S#t#T#o#t~-]cs~r~qr#ttu#tvw#tz{#t{|#t}!O#t!O!P#t!P!Q#t!Q![-U![!]#t!^!_#t!_!`#t!`!a#t!a!b#t!b!c#t!c!}#t#Q#R#t#R#S#t#T#o#t~.oes~r~qr#ttu#tvw#tz{#t{|#t}!O#t!O!P*[!P!Q#t!Q![.h![!]#t!^!_#t!_!`#t!`!a#t!a!b#t!b!c#t!c!}#t#Q#R#t#R#S.h#T#X#t#X#Y+t#Y#o#t~0VOY~~0[Ss~!O!P0h!Q![0V#R#S0V#X#Y0v~0mRs~!Q![0h#R#S0h#X#Y0v~0yP!Q![0|~1RPs~!Q![0|~1Zc^~qr1Utu1Uvw1Uz{1U{|1U}!O1U!O!P1U!P!Q1U!Q![1U![!]1U!^!_1U!_!`1U!`!a1U!a!b1U!b!c1U!c!}1U#Q#R1U#R#S1U#T#o1U~2kOZ~~2per~qr#ttu#tvw#tz{#t{|#t}!O#t!O!P#t!P!Q#t!Q![#t![!]#t!^!_#t!_!`#t!`!a#t!a!b#t!b!c#t!c!}#t!}#O4R#Q#R#t#R#S#t#T#o#t#o#p4W~4WOh~~4]Oj~~4bOc~~4gOb~~4lOf~~4qOX~~4vOe~~4{O]~",
  tokenizers: [backtickString, 0],
  topRules: {"Program":[0,2]},
  specialized: [{term: 34, get: value => spec_identifier[value] || -1}],
  tokenPrec: 136
});

const JanetLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Form: delimitedIndent({ closing: ")", align: false }),
                Tuple: delimitedIndent({ closing: "]", align: false }),
                Array: delimitedIndent({ closing: "]", align: false }),
                Struct: delimitedIndent({ closing: "}", align: false }),
                Table: delimitedIndent({ closing: "}", align: false }),
            }),
            foldNodeProp.add({
                Form: foldInside,
                Tuple: foldInside,
                Array: foldInside,
                Struct: foldInside,
                Table: foldInside,
            }),
            styleTags({
                Identifier: tags.name,
                Boolean: tags.bool,
                Number: tags.number,
                String: tags.string,
                LineComment: tags.lineComment,
                Nil: tags.null,
                Keyword: tags.atom,
                "( )": tags.paren,
                "@[ [ ]": tags.squareBracket,
                "@{ { }": tags.brace,
                "Pipe Comma Semicolon Quote Quasiquote": tags.punctuation,
                Special: tags.keyword,
            })
        ]
    }),
    languageData: {
        commentTokens: { line: "#" },
        closeBrackets: {
            brackets: ['(', '[', '{', '"', '`']
        },
    }
});
function janet() {
    return new LanguageSupport(JanetLanguage);
}

export { JanetLanguage, janet };
